summaryrefslogtreecommitdiffstats
path: root/matrace.in
diff options
context:
space:
mode:
Diffstat (limited to 'matrace.in')
-rwxr-xr-xmatrace.in72
1 files changed, 72 insertions, 0 deletions
diff --git a/matrace.in b/matrace.in
new file mode 100755
index 0000000..7d4d8c6
--- /dev/null
+++ b/matrace.in
@@ -0,0 +1,72 @@
+#!/bin/bash
+
+# This file is part of mutrace.
+#
+# Copyright 2009 Lennart Poettering
+#
+# mutrace is free software: you can redistribute it and/or modify it
+# under the terms of the GNU Lesser General Public License as
+# published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# mutrace is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# Lesser General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public
+# License along with mutrace. If not, see <http://www.gnu.org/licenses/>.
+
+if ! TEMP=`getopt -o +h --long frames:,help -n matrace -- "$@"` ; then
+ exit 1
+fi
+
+eval set -- "$TEMP"
+
+while : ; do
+ case $1 in
+ --frames)
+ export MATRACE_FRAMES="$2"
+ shift 2
+ ;;
+
+ -h|--help)
+ cat <<EOF
+@PACKAGE_STRING@
+
+Usage: matrace [OPTIONS...] APPLICATION [ARGUMENTS...]
+
+COMMANDS:
+ -h, --help Show this help
+
+OPTIONS:
+ --frames=INTEGER Set number of frames to show in stack traces
+EOF
+ exit 0
+ ;;
+ --)
+ shift
+ break
+ ;;
+
+ *)
+ echo "Parsing failed!" >&2
+ exit 1
+ ;;
+ esac
+done
+
+shift $(($OPTIND-1))
+
+if [ x"$1" = x ] ; then
+ echo "Please specify an application to profile!" >&2
+ exit 1
+fi
+
+if [ x"$LD_PRELOAD" = x ] ; then
+ export LD_PRELOAD="libmatrace.so"
+else
+ export LD_PRELOAD="$LD_PRELOAD libmatrace.so"
+fi
+
+exec "$@"